*
*  _blkcpy.s: part of libhmem(high speed memory operation library)
*  Copyright  1992-95  OONO Hiroo(oo), HGG00736@niftyserve.or.jp
*
.ifndef	MPU
MPU	equ	68000
.endif
	xref	__hmem_version

*
*	stack frame definitions
*
	.offset	4
dst	ds.l	1
src	ds.l	1
cnt	ds.l	1

*
*	regster definitions
*
~dst	.reg	a0
~src	.reg	a1
~cnt	.reg	d0
~saves	.reg	d3-d7/a3-a6

~list	.reg	d1-d7/a2-a6
regsiz	equ	48	* 12*4

	.text
	.even
.if	MPU>=68020
.ifdef	QUAD_ALIGN
	.quad
.endif
.endif
*
*	long*	_blkcpy(long* dst, long* src, int cnt)
*	dst	pointer of distination
*	src	pointer of source
*	cnt	block count(256bytes/block)
*
	xdef	_hblkcpy
_hblkcpy:
	xdef	__blkcpy
__blkcpy:
	movem.l	dst(sp),~dst/~src/a2	* a0 =dst, a1=src, a2=cnt
	move.l	a2,~cnt
	beq.s	_blkcpy_end

	movem.l	~saves,-(sp)		* save regs.

	subq.l	#1,~cnt

_blkcpy_loop:
	movem.l	regsiz*0(~src),~list	* thanks to Make up
	movem.l	~list,regsiz*0(~dst)	*  48

	movem.l	regsiz*1(~src),~list
	movem.l	~list,regsiz*1(~dst)	*  96

	movem.l	regsiz*2(~src),~list
	movem.l	~list,regsiz*2(~dst)	* 144

	movem.l	regsiz*3(~src),~list
	movem.l	~list,regsiz*3(~dst)	* 192

	movem.l	regsiz*4(~src),~list
	movem.l	~list,regsiz*4(~dst)	* 240

	movem.l	regsiz*5(~src),d1-d4	* rest 16
	movem.l	d1-d4,regsiz*5(~dst)
	lea.l	256(~src),~src
	lea.l	256(~dst),~dst
	dbra	~cnt,_blkcpy_loop	* MC68000 max 16M($100_00000)
.if	MPU>=68020
	clr.w	~cnt			* thanks to Project LIBC Group
	subq.l	#1,~cnt			*
	bcc.s	_blkcpy_loop		*
.endif

	movem.l	(sp)+,~saves		* restore regs
_blkcpy_end:
	move.l	dst(sp),d0
	rts
	.end
