*
*  _blkset.s: part of libhmem(high speed memory operation library)
*  Copyright  1992-95  OONO Hiro(oo), HGG00736@niftyserve.or.jp
*
.ifndef	MPU
MPU	equ	68000
.endif
	xref	__hmem_version

*
*	stack frame definitions
*
	.offset	4
dst	ds.l	1
dat	ds.l	1
cnt	ds.l	1

*
*	regster definitions
*
~dst	.reg	a0
~cnt	.reg	d0
~dat	.reg	d1
~saves	.reg	d3-d7/a3-a6

~list	.reg	d1-d7/a1-a6	* 13
regsiz	.equ	52		* 13*4

	.text
	.even
.if	MPU>=68020
.ifdef	QUAD_ALIGN
	.quad
.endif
.endif
**
** long* _blkset(long* dst, long dat, size_t cnt)
**
	xdef	_hblkset
_hblkset:
	xdef	__blkset
__blkset:
	movem.l	dst(sp),d0-d2		* d0=dst, d1=dat, d2=cnt

	movea.l	d0,~dst			* a0=dst
	move.l	d2,~cnt			* d0=cnt
	beq.s	blkset_end

	movem.l	~saves,-(sp)		* save regs
*
*	WX^Ƀf[^ݒ
*
	move.l	~dat,d2			*  2
	move.l	~dat,d3			*  3
	move.l	~dat,d4			*  4
	move.l	~dat,d5			*  5
	move.l	~dat,d6			*  6
	move.l	~dat,d7			*  7
	move.l	~dat,a1			*  8
	move.l	~dat,a2			*  9
	move.l	~dat,a3			* 10
	move.l	~dat,a4			* 11
	move.l	~dat,a5			* 12
	move.l	~dat,a6			* 13

	subq.l	#1,~cnt
blkset_loop:					* thanks to Make up
	movem.l	~list,regsiz*0(~dst)		*  52
	movem.l	~list,regsiz*1(~dst)		* 104
	movem.l	~list,regsiz*2(~dst)		* 156
	movem.l	~list,regsiz*3(~dst)		* 208
	movem.l	d1-d7/a1-a5,regsiz*4(~dst)	* rest 48

	lea	256(~dst),~dst
	dbra	~cnt,blkset_loop	* MC68000 max 16M($100_00000)
.if	MPU>=68020
	clr.w	~cnt			* thanks to Project LIBC Group
	subq.l	#1,~cnt			*
	bcc.s	blkset_loop		*
.endif

	movem.l	(sp)+,~saves		* restore regs
blkset_end:
	move.l	dst(sp),d0
	rts
	.end
