*
*  _memcchr.s: part of libhmem(high speed memory operation library)
*  Copyright  1992-95  OONO Hiroo(oo), HGG00736@niftyserve.or.jp
*
.ifndef	MPU
MPU	equ	68000
.endif
	xref	__hmem_version

COUNT	.equ	32

*
*	stack frame definitions
*
	.offset	4
buf	ds.l	1		* pointer of search buffer
c	ds.l	1		* search char
cnt	ds.l	1		* search count

*
*	register definitions
*
~buf	.reg	a0
~cntH	.reg	d0
~c	.reg	d1
~cnt	.reg	d2

	.text
	.even
.if	MPU>=68020
.ifdef	QUAD_ALIGN
	.quad
.endif
.endif
**
** void* memcchr(const void *buf, int c, size_t cnt) ;
**
	xdef	_hmemcchr
_hmemcchr:
	xdef	__memcchr
__memcchr:
	movem.l	buf(sp),d0/~c/~cnt	* d0=buf
	movea.l	d0,~buf
*	beq.s	memcchr_end

	cmp.l	#COUNT,~cnt
	bhs.s	memcchr_long
	subq.l	#1,~cnt			* adjust loop count
	bcs.s	memcchr_not_found
	move.l	~cnt,~cntH
	swap	~cntH

memcchr_loop:
	cmp.b	(~buf)+,~c		* c != *buf++
	dbne	~cnt,memcchr_loop
	bne.s	memcchr_found		* if ne then found
	dbra	~cntH,memcchr_loop	* coutinue
memcchr_not_found:
	moveq.l	#0,d0			* return NULL
memcchr_end:
	rts

memcchr_found:
	move.l	~buf,d0
	subq.l	#1,d0			* adjust address
	rts

memcchr_long:
	move.l	d3,a1
	move.b	~c,d3		* d3=x:x:x:c
	lsl.w	#8,~c		* ~c=x:x:c:0
	move.b	d3,~c		* ~c=x:x:c:c
	move.w	~c,d3		* d3=x:x:c:c
	swap	~c		* ~c=c:c:x:x
	move.w	d3,~c		* ~c=c:c:c:c
	move.l	a1,d3
	btst.l	#0,d0
	beq.s	memcchr_even
	subq.l	#1,~cnt
	cmp.b	(~buf)+,~c
	bne.s	memcchr_found
memcchr_even:
.if	MPU>=68040
	btst.l	#1,d0
	beq.s	memcchr_quad
	subq.l	#2,~cnt
	cmp.b	(~buf)+,~c
	bne.s	memcchr_found
	cmp.b	(~buf)+,~c
	bne.s	memcchr_found
memcchr_quad:
.endif
	move.w	~cnt,a1			* save cnt
	lsr.l	#2,~cnt			* cnt /= 4

	subq.l	#1,~cnt
	move.l	~cnt,~cntH
	swap	~cntH

memcchr_long_loop:
	cmp.l	(~buf)+,~c		* if (c != *buf++)
	dbne	~cnt,memcchr_long_loop
	bne.s	memcchr_long_found	* if ne then found
	dbra	~cntH,memcchr_long_loop

memcchr_long_rest:
	move.w	a1,~cnt
	btst.l	#1,~cnt
	beq.s	memcchr_rest_even
	cmp.b	(~buf)+,~c
	bne.s	memcchr_found
	cmp.b	(~buf)+,~c
	bne.s	memcchr_found
memcchr_rest_even:
	btst.l	#0,~cnt
	beq.s	memcchr_long_not_found
	cmp.b	(~buf)+,~c
	bne.s	memcchr_found
memcchr_long_not_found:
	moveq.l	#0,d0
	rts

memcchr_long_found:
	subq.l	#4,~buf
	cmp.b	(~buf)+,~c
	bne.s	memcchr_found
	cmp.b	(~buf)+,~c
	bne.s	memcchr_found
	cmp.b	(~buf)+,~c
	bne.s	memcchr_found
	move.l	~buf,d0
	rts
	.end
