/*
 *	check/cmemset.c: part of libhmem(high speed memory operation library)
 *	Copyright  1994,95  씎Y(oo), HGG00736@niftyserve.or.jp
 */
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	"hmemory.h"

#define	MEMSET_BUFSIZ	0x400
#define	memclr(p,n)		memset((p),0,(n))

char*	dp;
char*	sp;
char buf0[MEMSET_BUFSIZ];
char buf1[MEMSET_BUFSIZ];

#if	0
int	dumpstack(int d0, int d1, int d2, int a0, int a1, int a2)
{
	printf("d0=%p, d1=%p, d2=%p, a0=%p, a1=%p, a2=%p\n", d0, d1, d2, a0, a1, a2);
}
#endif

static void set_buf(char*p)
{
	int	i, n;

	for (n = 1, i = 0; i < MEMSET_BUFSIZ; i++) {
		p[i] = n++;
		if ((n &= 0xff) == 0) n = 1;
	}
}

static void	dump_buf(unsigned char* p, int n)
{
	int	i;

	printf("%p\n", p);
	for (i = 0; i < n; i++) {
		printf("%02x", p[i]);
		if ((i&0x1f) == 31) fputc('\n', stdout);
		else if ((i&0x7) == 7) fputc('-', stdout);
		else fputc(' ', stdout);
	}
}

static void	check_buf(char* p1, int n)
{
	int	dofs;
	char*	p;

	dofs = p1 - dp;
	printf("dp=%p, dofs=%d,n=%d\n", dp, dofs, n);
	set_buf(dp);
	p = memset(p1, 0, n);
	if (p != p1
	||  _memcchr(p1, 0, n)
	||  (dofs && memcmp(buf0, dp, dofs))
	||  memcmp(buf0+dofs+n, dp+dofs+n, MEMSET_BUFSIZ-(dofs+n))) {
		if (p != p1) printf("p != p1\n");
		if (_memcchr(p1, 0, n)) printf("_memcchr(p1, 0, n)\n");
		if (dofs && _memcchr(dp, 0, dofs)) printf("(dofs && _memcchr(dp, 0, dofs))\n");
		if (memcmp(buf0+dofs+n, dp+dofs+n, MEMSET_BUFSIZ-(dofs+n)))
		    printf("memcmp(buf0+dofs+n, dp+dofs+n, MEMSET_BUFSIZ-(dofs+n)))\n");
		fprintf(stderr, "error %p, %d\n", p1, n);
		dump_buf((unsigned char*)dp, MEMSET_BUFSIZ);
		exit(1);
	}
#if	0
	dump_buf(dp, MEMSET_BUFSIZ);
	getch();
#endif
}

static void	check(char* p1, int n)
{
	check_buf(p1+0, n);
	check_buf(p1+1, n);
	check_buf(p1+2, n);
	check_buf(p1+3, n);
}

void	main(void)
{
	set_buf(buf0);
	dp = buf1;
	check(dp, 1);
	check(dp, 4);
	check(dp, 8);
	check(dp, 16);
	check(dp, 32);
	check(dp, 256);
	check(dp, 512);

	printf("ok\n");
	exit(0);
}
