*
*  memcmp.s: part of libhmem(high speed memory operation library)
*  Copyright  1992-95  씎Y(oo), HGG00736@niftyserve.or.jp
*
.ifndef	MPU
MPU	equ	68000
.endif
	xref	__hmem_version

count	equ	16			. O[hrJnoCg


	.offset	4
mem1:	ds.l	1
mem2:	ds.l	1
len:	ds.l	1			. roCg

	.text
	.even
.if	MPU>=68020
.ifdef	QUAD_ALIGN
	.quad
.endif
.endif
**
** int	memcmp(const void* mem1, const void* mem2, size_t len)
**
	xdef	_hmemcmp
_hmemcmp:
	xdef	_memcmp
_memcmp:
	movem.l	mem1(sp),a0-a2		. a0=mem1, a1=mem2, a2=len
	move.l	a2,d2
	ble	memcmp_equal		. len ܂͂OȂI
	cmpa.l	a0,a1
	beq	memcmp_equal		. ̈̔rȂI

	cmpi.l	#count,d2		. count byteŝƂ̓oCgr
	bhs	check_align

memcmp_byte:
	subq.l	#1,d2			. [vJE^␳
	move.l	d2,d1
	swap	d1
.if	MPU>=68020
	.quad
.endif
memcmp_byte_loop:
	cmpm.b	(a1)+,(a0)+
	dbne	d2,memcmp_byte_loop
	bhi	memcmp_plus		. mem2<mem1
	blo	memcmp_minus		. mem2>mem1
	dbne	d1,memcmp_byte_loop
memcmp_equal:
	moveq.l	#0,d0			. ret=0
memcmp_end:
	rts
memcmp_plus:
	moveq.l	#1,d0			. ret=1
	rts
memcmp_minus:
	moveq.l	#-1,d0			. ret=-1
	rts

check_align:
	move.l	a0,d0			. a0=r̈P
	move.l	a1,d1			. a1=r̈Q
	eor.w	d0,d1			. Ԓnibus errorh~j
	btst.l	#0,d1			. ԒnH
	bne	memcmp_byte			. ACgs

	btst.l	#0,d0			. [hACgɂ
	beq.s	align_even
	cmpm.b	(a1)+,(a0)+
	bhi	memcmp_plus		. mem2<mem1
	bcs	memcmp_minus		. mem2>mem1
	subq.l	#1,d2
align_even:
.if	MPU>=68040
	btst.l	#1,d1			. [hACg ?
	beq.s	check_align2

memcmp_word:
	move.l	d2,a2
	lsr.l	#1,d2
	subq.l	#1,d2
	move.l	d2,d1
	swap	d1
memcmp_word_loop:
	cmpm.w	(a1)+,(a0)+
	dbne	d2,memcmp_word_loop
	bhi	memcmp_plus		. mem2<mem1
	bcs	memcmp_minus		. mem2>mem1
	dbne	d1,memcmp_word_loop
	move.w	a2,d2
	andi.w	#1,d2
	beq.s	memcmp_equal
	cmpm.b	(a1)+,(a0)+
	bhi	memcmp_plus		. mem2<mem1
	bcs	memcmp_minus		. mem2>mem1
	bra	memcmp_equal
.endif

check_align2:
.if	MPU>=68020
	btst.l	#1,d0			. O[hACgɂ
	beq.s	align_quad
	cmpm.w	(a1)+,(a0)+
	bhi	memcmp_plus		. mem2<mem1
	bcs	memcmp_minus		. mem2>mem1
	subq.l	#2,d2
align_quad:
.endif

memcmp_long:
	move.l	d2,a2
	lsr.l	#2,d2			. d2/4
	subq.l	#1,d2
	move.l	d2,d1
	swap	d1

memcmp_long_loop:
	cmpm.l	(a1)+,(a0)+
	dbne	d2,memcmp_long_loop
	bhi	memcmp_plus		. mem2<mem1
	bcs	memcmp_minus		. mem2>mem1
	dbne	d1,memcmp_long_loop

	move.l	a2,d2
	btst.l	#1,d2
	beq	memcmp_long_rest
	cmp.w	(a1)+,(a0)+
	bhi	memcmp_plus		. mem2<mem1
	bcs	memcmp_minus		. mem2>mem1
memcmp_long_rest:
	andi.w	#1,d2
	beq	memcmp_equal
	cmpm.b	(a1)+,(a0)+
	bhi	memcmp_plus		. mem2<mem1
	bcs	memcmp_minus		. mem2>mem1
	bra	memcmp_equal
	.end
