*
*  memicmp.s: part of libhmem(high speed memory operation library)
*  Copyright  1992-95  씎Y(oo), HGG00736@niftyserve.or.jp
*
.ifndef	MPU
MPU	equ	68000
.endif

	xref	__hmem_version
	xdef	_hmemicmp
	xdef	_memicmp
	xdef	_memcmpi

count	equ	16

	.offset	4
mem0:	ds.l	1
mem1:	ds.l	1
len:	ds.l	1			. roCg

~m0	.reg	a0
~m1	.reg	a1
~save	.reg	a2
~c0	.reg	d0
~c1	.reg	d1
~len	.reg	d2
~c	.reg	d3

	.text
	.even
.if	MPU>=68020
.ifdef	QUAD_ALIGN
	.quad
.endif
.endif
_hmemicmp:
**
** int	memicmp(const void* mem1, const void* mem2, size_t len)
**
_memicmp:
**
** int	memcmpi(const void* mem1, const void* mem2, size_t len)
**
_memcmpi:
	movem.l	mem0(sp),~m0/~m1/~save
	moveq.l	#0,~c0
	moveq.l	#0,~c1
	move.l	~save,~len
	ble.s	memcmpi_end		* <= 0
	cmpa.l	~m0,~m1
	beq.s	memcmpi_end		* the same area

	move.l	~c,~save
	subq.l	#1,~len			* adjust len

memcmpi_loop:
	move.b	(~m0)+,~c0
	move.b	(~m1)+,~c1
	cmp.b	~c0,~c1
	bne.s	memcmpi_conv
	dbra	~len,memcmpi_loop
	clr.w	~len			* thanks to Project LIBC Group
	subq.l	#1,~len
	bcc.s	memcmpi_loop
	bra.s	memcmpi_end

memcmpi_conv:
	move.b	~c0,~c
	subi.b	#'A',~c
	cmpi.b	#'Z'-'A',~c
	bhi.s	@f
	add.b	#'a'-'A',~c0
@@:
	move.b	~c1,~c
	subi.b	#'A',~c
	cmpi.b	#'Z'-'A',~c
	bhi.s	@f
	add.b	#'a'-'A',~c1
@@:
	cmp.b	~c1,~c0			. Pr
	bne.s	memcmpi_end
	dbra	~len,memcmpi_loop
	clr.w	~len
	subq.l	#1,~len
	bcc.s	memcmpi_loop
memcmpi_end:
	move.l	~save,~c
	sub.l	~c1,~c0
	rts
	.end
