*
*  memset.s: part of libhmem(high speed memory operation library)
*  Copyright  1992-95  씎Y(oo), HGG00736@niftyserve.or.jp
*
.ifndef	MPU
MPU	equ	68000
.endif

	xref	__hmem_version
	xdef	_bzero
	xdef	_setmem

	xdef	_hmemset
	xdef	_memset

count1	equ	16		. 16oCgubN]JnoCg
count2	equ	512		. 32oCgubN]JnoCg

	.offset	4
buf:	ds.l	1
par1:	ds.l	1
par2:	ds.l	1

	.text
	.even
.if	MPU>=68020
.ifdef	QUAD_ALIGN
	.quad
.endif
.endif
**
** void	bzero( void* buf , size_t len )
**
_bzero:
	moveq.l	#0,d1
	bra.s	setmem

.if	MPU>=68020
.ifdef	QUAD_ALIGN
	.quad
.endif
.endif
**
** void	setmem( void* buf , size_t len , int c )
**
_setmem:
	move.l	par2(sp),d1
setmem:
	move.l	buf(sp),d0
	move.l	par1(sp),d2
	bra.s	memset

.if	MPU>=68020
.ifdef	QUAD_ALIGN
	.quad
.endif
.endif
**
** void* memset( void* buf , int c , size_t len )
**
_hmemset:
_memset:
	movem.l	buf(sp),d0-d2		. d0=buf, d1=c, d2=len
memset:
	movea.l	d0,a0
	cmpi.l	#count1,d2
	bcc.s	check_align
	subq.w	#1,d2
	bcs	memset_end

memset_loop:
	move.b	d1,(a0)+
	dbra	d2,memset_loop
*	move.l	buf(sp),d0
memset_end:
	rts

*
*	~XACg␳
*
check_align:
	btst.l	#0,d0			. AhX?
	beq.s	align_even
	move.b	d1,(a0)+		. AhX
	subq.l	#1,d2
*	beq.s	blkset1_end		. d2 >= count1 - 1

align_even:
	.if	MPU>=68020
*
*	32bit oXŐ\グׂɒǉ
*
	btst.l	#1,d0			. [hAhX?
	beq.s	align_quad
	move.b	d1,(a0)+		. quad AhX
	move.b	d1,(a0)+
	subq.l	#2,d2
*	beq.s	blkset1_end		. d2 >= 8
	.endif
align_quad:
*
*	d1:xxxc -> d1:cccc
*
	move.b	d1,d0
	lsl.w	#8,d1
	move.b	d0,d1			. d1:xxcc
	move.w	d1,d0
	swap	d1
	move.w	d0,d1			. d1:cccc

	move.w	d2,d0
	add.l	d2,a0			. buf += len
	move.l	d1,a1
	move.l	d1,a2

	cmpi.l	#count2,d2
	bcc.s	blkset2
blkset1:
*
*	16oCgȉ̗]
*
	andi.w	#%1111,d0
	beq.s	blkset1_body
	subq.w	#1,d0
blkset1_rest:
	move.b	d1,-(a0)
	dbra	d0,blkset1_rest
blkset1_body:
	move.l	d1,d0
*
	lsr.w	#4,d2
	beq.s	blkset1_end		. 16oCgȉ̎̓`FbN
	subq.w	#1,d2

blkset1_loop:
	movem.l	d0/d1/a1/a2,-(a0)
	dbra	d2,blkset1_loop
blkset1_end:
	move.l	buf(sp),d0
	rts

blkset2:
	movem.l	d3-d7,-(sp)
*
*	32oCgȉ̗]
*
	andi.w	#%11111,d0
	beq.s	blkset2_body
	subq.w	#1,d0
blkset2_rest:
	move.b	d1,-(a0)
	dbra	d0,blkset2_rest
blkset2_body:
	move.l	d1,d3
	move.l	d1,d4
	move.l	d1,d5
	move.l	d1,d6
	move.l	d1,d7
*
	lsr.l	#5,d2
*	beq.s	blkset2_end
	subq.l	#1,d2
	move.l	d2,d0
	swap	d0

blkset2_loop:
	movem.l	d1/d3-d7/a1/a2,-(a0)
	dbra	d2,blkset2_loop
	dbra	d0,blkset2_loop
blkset2_end:
	movem.l	(sp)+,d3-d7
	move.l	buf(sp),d0
	rts
	.end
